signature CONTROL =
   sig
      type ans
      val reset : (unit -> ans) -> ans
      val shift : (('a -> ans) -> ans) -> 'a
   end;

functor Control (type ans) : CONTROL =
   struct

      open SMLofNJ

      val mk : ans cont ref =
	  ref (callcc (fn k => (callcc (throw k); raise Fail "impossible")))
      fun abort x = throw (!mk) x

      type ans = ans
      fun reset t = 
	  let val m = !mk
	      val r = callcc (fn k => (mk := k; abort (t())))
	  in mk := m; r end

      fun shift h =
	  callcc (fn k => abort (h (fn v => reset (fn ()=>throw k v))))
   end;

structure IntCtrl = Control (type ans = int)

val test = 1 + IntCtrl.reset (fn () => 2 * IntCtrl.shift (fn k => k (k 10)));
(* should return 41 *)




signature SYNTAX =
sig
datatype M = m_blah of int
end

structure Syntax : SYNTAX =
struct
  datatype M = m_blah of int
end

  structure M_Control = Control (type ans = Syntax.M);



signature EVAL =
sig
  structure Syntax : SYNTAX
  val foo: Syntax.M
end

functor Eval (structure Syntax : SYNTAX) : EVAL =
struct
  structure Syntax = Syntax
  open Syntax


  fun try x = M_Control.reset (fn () => m_blah(5))

  val foo = m_blah(5)
end
