(*
  simple - a formal system demonstrating cyclic values
  Copyright (C) 1996  Scott Draves <spot@cs.cmu.edu>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundationeither version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this programif not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

signature EVAL =
sig
  structure Syntax : SYNTAX

  type Env = Syntax.Name -> Syntax.M
  val empty_env: Env
  val extend: Syntax.M -> Syntax.M -> Env -> Env

  val trace_eval: bool ref
  val trace_let: bool ref
  val trace_apply: bool ref

  val eval: Syntax.Program -> Env -> Syntax.M -> Syntax.Exp -> (Syntax.M * Syntax.M)
  val apply: bool -> Syntax.Program -> Syntax.Name -> Syntax.M -> Syntax.M -> (Syntax.M * Syntax.M)
  val run: Syntax.Program -> Syntax.Name -> Syntax.Name -> Syntax.Name -> (Syntax.M * Syntax.M)
  val clear: Syntax.Program -> unit
end
